Index: trunk/MagicSoft/Mars/datacenter/db/culminating.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/culminating.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/culminating.php	(revision 8180)
@@ -227,5 +227,5 @@
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/datacheck.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/datacheck.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/datacheck.php	(revision 8180)
@@ -424,5 +424,5 @@
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/datasetinfo-aio.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/datasetinfo-aio.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/datasetinfo-aio.php	(revision 8180)
@@ -258,5 +258,5 @@
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/datasetinfo.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/datasetinfo.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/datasetinfo.php	(revision 8180)
@@ -380,5 +380,5 @@
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/dbstatus.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/dbstatus.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/dbstatus.php	(revision 8180)
@@ -361,5 +361,5 @@
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/findoffdata.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/findoffdata.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/findoffdata.php	(revision 8180)
@@ -413,5 +413,5 @@
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, $limitsmean, $limitsmin, $limitsmax, $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, $limitsmean, $limitsmin, $limitsmax, "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/index.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/index.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/index.php	(revision 8180)
@@ -376,5 +376,5 @@
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/menu.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/menu.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/menu.php	(revision 8180)
@@ -257,8 +257,8 @@
 
     CheckBox("fStartTime",     "StartTime");
-    CheckBox("fFailedTime",    "FailedTime");
-    CheckBox("fReturnCode",    "ErrCode");
-    CheckBox("fFailedCode",    "RetCode");
-    CheckBox("fFailedCodeAdd", "CodeAdd");
+    CheckBox("fFailedTime",    "FailTime");
+    CheckBox("fReturnCode",    "RetCode");
+    CheckBox("fFailedCode",    "FailCode");
+    CheckBox("fFailedCodeAdd", "FailCodeAdd");
 
     printf("  </tr>\n");
@@ -473,4 +473,20 @@
     printf("Night&nbsp;(yyyy-mm-dd)&nbsp;from&nbsp;<input name=\"fStartDate\" type=\"text\" size=\"10\" maxlength=\"10\" value=\"%s\">\n", $timemin);
     printf("to&nbsp;<input name=\"fStopDate\" type=\"text\" size=\"10\" maxlength=\"10\" value=\"%s\">&nbsp;&nbsp;&nbsp;&nbsp;\n", $timemax);
+}
+
+function PrintStarRangeMenu($host,$user,$pw,$db)
+{
+    if (empty($_GET["fStarStart"]))
+        $starmin = GetMin("fStar", "SequenceProcessStatus", $host, $user, $pw, $db);
+    else
+        $starmin = $_GET["fStarStart"];
+
+    if (empty($_GET["fStarStop"]))
+        $starmax = GetMax("fStar", "SequenceProcessStatus", $host, $user, $pw, $db);
+    else
+        $starmax = $_GET["fStarStop"];
+
+    printf("<p>StarDone&nbsp;(yyyy-mm-dd)&nbsp;from&nbsp;<input name=\"fStarStart\" type=\"text\" size=\"10\" maxlength=\"10\" value=\"%s\">\n", $starmin);
+    printf("to&nbsp;<input name=\"fStarStop\" type=\"text\" size=\"10\" maxlength=\"10\" value=\"%s\">&nbsp;&nbsp;&nbsp;&nbsp;\n", $starmax);
 }
 
Index: trunk/MagicSoft/Mars/datacenter/db/opticaldata.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/opticaldata.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/opticaldata.php	(revision 8180)
@@ -241,5 +241,5 @@
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/printtable.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/printtable.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/printtable.php	(revision 8180)
@@ -50,5 +50,5 @@
                 (
                 );
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             }
             else
Index: trunk/MagicSoft/Mars/datacenter/db/querycal.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/querycal.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/querycal.php	(revision 8180)
@@ -199,5 +199,5 @@
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/querymc.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/querymc.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/querymc.php	(revision 8180)
@@ -243,5 +243,5 @@
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/queryrbk.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/queryrbk.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/queryrbk.php	(revision 8180)
@@ -71,5 +71,5 @@
                 (
                 );
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             }
             else
Index: trunk/MagicSoft/Mars/datacenter/db/queryseq.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/queryseq.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/queryseq.php	(revision 8180)
@@ -318,5 +318,5 @@
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/querystar.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/querystar.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/querystar.php	(revision 8180)
@@ -164,5 +164,5 @@
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/runinfo-aio.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/runinfo-aio.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/runinfo-aio.php	(revision 8180)
@@ -291,5 +291,5 @@
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/runinfo.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/runinfo.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/runinfo.php	(revision 8180)
@@ -522,5 +522,5 @@
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/sequinfo-aio.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/sequinfo-aio.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/sequinfo-aio.php	(revision 8180)
@@ -338,5 +338,5 @@
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, $limitsmean, $limitsmin, $limitsmax, $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, $limitsmean, $limitsmin, $limitsmax, "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/sequinfo.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/sequinfo.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/sequinfo.php	(revision 8180)
@@ -636,5 +636,5 @@
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/sources.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/sources.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/sources.php	(revision 8180)
@@ -101,5 +101,5 @@
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/statusrps.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/statusrps.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/statusrps.php	(revision 8180)
@@ -207,5 +207,5 @@
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/statussbs.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/statussbs.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/statussbs.php	(revision 8180)
@@ -183,5 +183,5 @@
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);
Index: trunk/MagicSoft/Mars/datacenter/db/statussps.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/statussps.php	(revision 8175)
+++ trunk/MagicSoft/Mars/datacenter/db/statussps.php	(revision 8180)
@@ -196,5 +196,5 @@
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
             else
                 PrintText($result0);