Index: trunk/MagicSoft/Mars/msignal/MExtractBlindPixel.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractBlindPixel.cc	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractBlindPixel.cc	(revision 8304)
@@ -150,5 +150,5 @@
 }
 
-void MExtractBlindPixel::SetRange(Byte_t hifirst, Byte_t hilast, Byte_t lofirst, Byte_t lolast)
+void MExtractBlindPixel::SetRange(Byte_t hifirst, Byte_t hilast, Int_t lofirst, Byte_t lolast)
 {
 
Index: trunk/MagicSoft/Mars/msignal/MExtractBlindPixel.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractBlindPixel.h	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractBlindPixel.h	(revision 8304)
@@ -88,5 +88,5 @@
   
   void SetRange         ( const Byte_t  hifirst=0, const Byte_t hilast=0, 
-   		          const Byte_t  lofirst=0, const Byte_t lolast=0 );
+   		          const Int_t   lofirst=0, const Byte_t lolast=0 );
   void SetResolution    ( const Float_t f=fgResolution       )  { fResolution     = f;     }
   
Index: trunk/MagicSoft/Mars/msignal/MExtractPINDiode.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractPINDiode.cc	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractPINDiode.cc	(revision 8304)
@@ -145,5 +145,5 @@
 // - fSqrtLoGainSamples to: 0.
 //  
-void MExtractPINDiode::SetRange(Byte_t hifirst, Byte_t hilast, Byte_t lofirst, Byte_t lolast)
+void MExtractPINDiode::SetRange(Byte_t hifirst, Byte_t hilast, Int_t lofirst, Byte_t lolast)
 {
 
Index: trunk/MagicSoft/Mars/msignal/MExtractPINDiode.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractPINDiode.h	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractPINDiode.h	(revision 8304)
@@ -56,5 +56,5 @@
 
   // Setters
-  void SetRange(Byte_t hifirst=0, Byte_t hilast=0, Byte_t lofirst=0, Byte_t lolast=0);
+  void SetRange(Byte_t hifirst=0, Byte_t hilast=0, Int_t lofirst=0, Byte_t lolast=0);
   void SetPINDiodeIdx  ( const UInt_t idx=fgPINDiodeIdx    ) { fPINDiodeIdx   = idx; }
   void SetLowerFitLimit( const Byte_t lim=fgLowerFitLimit  ) { fLowerFitLimit = lim; }
Index: trunk/MagicSoft/Mars/msignal/MExtractTime.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTime.cc	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractTime.cc	(revision 8304)
@@ -1,4 +1,4 @@
 /* ======================================================================== *\
-! $Name: not supported by cvs2svn $:$Id: MExtractTime.cc,v 1.22 2006-10-24 08:24:52 tbretz Exp $
+! $Name: not supported by cvs2svn $:$Id: MExtractTime.cc,v 1.23 2007-02-04 15:30:16 tbretz Exp $
 ! --------------------------------------------------------------------------
 !
@@ -86,4 +86,5 @@
 
 const TString MExtractTime::fgNameTimeCam   = "MArrivalTimeCam";
+
 // --------------------------------------------------------------------------
 //
@@ -109,6 +110,4 @@
 }
 
-
-
 // --------------------------------------------------------------------------
 //
@@ -132,69 +131,7 @@
 }
 
-// --------------------------------------------------------------------------
-//
-// The ReInit calls:
-// -  MExtractor::ReInit()
-//
-// Call: 
-// - MArrivalTimeCam::SetUsedFADCSlices(fHiGainFirst, fHiGainLast, fNumHiGainSamples,
-//                                      fLoGainFirst, fLoGainLast, fNumLoGainSamples);
-/*
-Bool_t MExtractTime::ReInit(MParList *pList)
-{
-    if (!MExtractor::ReInit(pList))
-        return kFALSE;
-
-//    if (fArrTime)
-//      fArrTime->SetUsedFADCSlices(fHiGainFirst, fHiGainLast+fHiLoLast, fLoGainFirst, fLoGainLast);
-
-    return kTRUE;
-}
-*/
-// --------------------------------------------------------------------------
-//
-// Calculate the integral of the FADC time slices and store them as a new
-// pixel in the MArrivalTimeCam container.
-/*
-Int_t MExtractTime::Process()
-{
-
-
-  MRawEvtPixelIter pixel(fRawEvt);
-
-  while (pixel.Next())
-    {
-      //
-      // Find signal in hi- and lo-gain
-      //
-      Float_t timehi=0., deltatimehi=0.;
-      Byte_t sathi=0;
-
-      const Int_t pixid = pixel.GetPixelId();
-      const MPedestalPix  &ped = (*fPedestals)[pixid];
-      MArrivalTimePix &pix = (*fArrTime)[pixid];
-
-      FindTimeHiGain(pixel.GetHiGainSamples()+fHiGainFirst, timehi, deltatimehi, sathi, ped);
-
-      Float_t timelo=0., deltatimelo=0.;
-      Byte_t satlo=0;
-
-      if ((sathi)&&pixel.HasLoGain())
-	  FindTimeLoGain(pixel.GetLoGainSamples()+fLoGainFirst, timelo, deltatimelo, satlo, ped);
-
-      pix.SetArrivalTime(timehi, deltatimehi, timelo-fOffsetLoGain, deltatimelo);
-      pix.SetGainSaturation(sathi, satlo);
- 
-    }
-
-    fArrTime->SetReadyToSave();
-
-    return kTRUE;
-}*/
 
 void MExtractTime::Print(Option_t *o) const
 {
-//    if (IsA()==MExtractTime::Class())
-//        *fLog << GetDescriptor() << ":" << endl;
     MExtractor::Print(o);
     *fLog << " Offset Lo-Gain:     " << fOffsetLoGain << endl;
Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.h	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.h	(revision 8304)
@@ -30,7 +30,8 @@
   MExtractTimeAndCharge(const char *name=NULL, const char *title=NULL);
   
-  Int_t  GetWindowSizeHiGain  () const { return fWindowSizeHiGain; }
-  Int_t  GetWindowSizeLoGain  () const { return fWindowSizeLoGain; }
-  Byte_t GetLoGainSwitch      () const { return fLoGainSwitch;     }
+  Int_t   GetWindowSizeHiGain  () const { return fWindowSizeHiGain; }
+  Int_t   GetWindowSizeLoGain  () const { return fWindowSizeLoGain; }
+  Float_t GetLoGainStartShift  () const { return fLoGainStartShift; }
+  Byte_t  GetLoGainSwitch      () const { return fLoGainSwitch;     }
 
   void SetLoGainStartShift( const Float_t f=fgLoGainStartShift ) { fLoGainStartShift = f + fOffsetLoGain;  }
Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.cc	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.cc	(revision 8304)
@@ -1,4 +1,4 @@
 /* ======================================================================== *\
-! $Name: not supported by cvs2svn $:$Id: MExtractTimeAndChargeDigitalFilter.cc,v 1.76 2007-01-16 14:14:37 tbretz Exp $
+! $Name: not supported by cvs2svn $:$Id: MExtractTimeAndChargeDigitalFilter.cc,v 1.77 2007-02-04 15:30:16 tbretz Exp $
 ! --------------------------------------------------------------------------
 !
@@ -86,5 +86,5 @@
 const Byte_t  MExtractTimeAndChargeDigitalFilter::fgHiGainFirst             =  0;
 const Byte_t  MExtractTimeAndChargeDigitalFilter::fgHiGainLast              = 16;
-const Byte_t  MExtractTimeAndChargeDigitalFilter::fgLoGainFirst             =  1;
+const Int_t   MExtractTimeAndChargeDigitalFilter::fgLoGainFirst             =  1;
 const Byte_t  MExtractTimeAndChargeDigitalFilter::fgLoGainLast              = 14;
 const Int_t   MExtractTimeAndChargeDigitalFilter::fgBinningResolutionHiGain = 10;
@@ -137,5 +137,5 @@
     }
 
-    if (windowl > fLoGainLast-fLoGainFirst+1)
+    if (windowl > (int)fLoGainLast-fLoGainFirst+1)
     {
         *fLog << err << "ERROR - The new hi-gain window size exceeds the extraction range." << endl;
Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.h	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.h	(revision 8304)
@@ -17,5 +17,5 @@
     static const Byte_t  fgHiGainFirst;             //! Default for fHiGainFirst       (now set to: 0)
     static const Byte_t  fgHiGainLast;              //! Default for fHiGainLast        (now set to:14)
-    static const Byte_t  fgLoGainFirst;             //! Default for fLoGainFirst       (now set to: 3)
+    static const Int_t   fgLoGainFirst;             //! Default for fLoGainFirst       (now set to: 3)
     static const Byte_t  fgLoGainLast;              //! Default for fLoGainLast        (now set to:14)
     static const Int_t   fgBinningResolutionHiGain; //! Default for fBinningResolutionHiGain (now set to: 10)
Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.cc	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.cc	(revision 8304)
@@ -1,4 +1,4 @@
 /* ======================================================================== *\
-! $Name: not supported by cvs2svn $:$Id: MExtractTimeAndChargeSpline.cc,v 1.65 2007-02-03 20:07:52 tbretz Exp $
+! $Name: not supported by cvs2svn $:$Id: MExtractTimeAndChargeSpline.cc,v 1.66 2007-02-04 15:30:16 tbretz Exp $
 ! --------------------------------------------------------------------------
 !
@@ -158,5 +158,5 @@
 const Byte_t  MExtractTimeAndChargeSpline::fgHiGainFirst      = 0;
 const Byte_t  MExtractTimeAndChargeSpline::fgHiGainLast       = 14;
-const Byte_t  MExtractTimeAndChargeSpline::fgLoGainFirst      = 1;
+const Int_t   MExtractTimeAndChargeSpline::fgLoGainFirst      = 1;
 const Byte_t  MExtractTimeAndChargeSpline::fgLoGainLast       = 14;
 const Float_t MExtractTimeAndChargeSpline::fgResolution       = 0.05;
@@ -205,7 +205,6 @@
 // explicit call to SetChargeType().
 //
-void MExtractTimeAndChargeSpline::SetRange(Byte_t hifirst, Byte_t hilast, Byte_t lofirst, Byte_t lolast)
-{
-
+void MExtractTimeAndChargeSpline::SetRange(Byte_t hifirst, Byte_t hilast, Int_t lofirst, Byte_t lolast)
+{
   MExtractor::SetRange(hifirst, hilast, lofirst, lolast);
 
Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.h	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeSpline.h	(revision 8304)
@@ -17,5 +17,5 @@
     static const Byte_t  fgHiGainFirst;      //! Default for fHiGainFirst  (now set to: 2)
     static const Byte_t  fgHiGainLast;       //! Default for fHiGainLast   (now set to: 14)
-    static const Byte_t  fgLoGainFirst;      //! Default for fLoGainFirst  (now set to: 2)
+    static const Int_t   fgLoGainFirst;      //! Default for fLoGainFirst  (now set to: 2)
     static const Byte_t  fgLoGainLast;       //! Default for fLoGainLast   (now set to: 14)
     static const Float_t fgResolution;       //! Default for fResolution   (now set to: 0.003)
@@ -60,5 +60,5 @@
     Float_t GetFallTimeHiGain() const { return fFallTimeHiGain; }
 
-    void SetRange(Byte_t hifirst=0, Byte_t hilast=0, Byte_t lofirst=0, Byte_t lolast=0 );
+    void SetRange(Byte_t hifirst=0, Byte_t hilast=0, Int_t lofirst=0, Byte_t lolast=0 );
 
     void SetResolution(const Float_t f=fgResolution)  { fResolution  = f;  }
Index: trunk/MagicSoft/Mars/msignal/MExtractedSignalCam.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractedSignalCam.cc	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractedSignalCam.cc	(revision 8304)
@@ -34,4 +34,9 @@
 //  - fNdf
 //
+// Class Version 4:
+// ----------------
+//  - Byte_t fFirstUsedSliceLoGain;         // First Low Gain FADC used for extraction (incl.)
+//  + Int_t  fFirstUsedSliceLoGain;         // First Low Gain FADC used for extraction (incl.)
+//
 /////////////////////////////////////////////////////////////////////////////
 #include "MExtractedSignalCam.h"
Index: trunk/MagicSoft/Mars/msignal/MExtractedSignalCam.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractedSignalCam.h	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractedSignalCam.h	(revision 8304)
@@ -20,5 +20,5 @@
 
   Byte_t fFirstUsedSliceHiGain;        // First High Gain FADC used for extraction (incl.)
-  Byte_t fFirstUsedSliceLoGain;        // First Low Gain FADC used for extraction (incl.)
+  Int_t  fFirstUsedSliceLoGain;        // First Low Gain FADC used for extraction (incl.)
   
   Byte_t fLastUsedSliceHiGain;         // Last High Gain FADC used for extraction (incl.)
@@ -40,6 +40,5 @@
 
     Byte_t  GetFirstUsedSliceHiGain()    const { return fFirstUsedSliceHiGain; }
-    Byte_t  GetFirstUsedSliceLoGain()    const { return fFirstUsedSliceLoGain; }
-
+    Int_t   GetFirstUsedSliceLoGain()    const { return fFirstUsedSliceLoGain; }
     Byte_t  GetLastUsedSliceHiGain()     const { return fLastUsedSliceHiGain;  }
     Byte_t  GetLastUsedSliceLoGain()     const { return fLastUsedSliceLoGain;  }
@@ -50,5 +49,5 @@
     void    SetLogStream     ( MLog *lg  );
     void    SetUsedFADCSlices(Byte_t firsth, Byte_t lasth, Float_t winh,
-                              Byte_t firstl, Byte_t lastl, Float_t winl)
+                              Int_t  firstl, Byte_t lastl, Float_t winl)
     {
       fFirstUsedSliceHiGain    = firsth;
@@ -66,5 +65,5 @@
     void DrawPixelContent(Int_t num) const;
 
-    ClassDef(MExtractedSignalCam, 3)	// Storage Container for extracted signals in the camera
+    ClassDef(MExtractedSignalCam, 4)	// Storage Container for extracted signals in the camera
 };
 
Index: trunk/MagicSoft/Mars/msignal/MExtractor.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractor.cc	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractor.cc	(revision 8304)
@@ -141,5 +141,5 @@
 }
 
-void MExtractor::SetRange(Byte_t hifirst, Byte_t hilast, Byte_t lofirst, Byte_t lolast)
+void MExtractor::SetRange(Byte_t hifirst, Byte_t hilast, Int_t lofirst, Byte_t lolast)
 {
     fHiGainFirst = hifirst;
@@ -397,5 +397,5 @@
 {
     Byte_t hf = fHiGainFirst;
-    Byte_t lf = fLoGainFirst;
+    Int_t  lf = fLoGainFirst;
     Byte_t hl = fHiGainLast;
     Byte_t ll = fLoGainLast;
Index: trunk/MagicSoft/Mars/msignal/MExtractor.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractor.h	(revision 8297)
+++ trunk/MagicSoft/Mars/msignal/MExtractor.h	(revision 8304)
@@ -48,5 +48,5 @@
   Byte_t   fHiGainFirst;                   // First FADC slice nr. to extract the High Gain signal
   Byte_t   fHiGainLast;                    // Last FADC slice nr. to extract the High Gain signal
-  Byte_t   fLoGainFirst;                   // First FADC slice nr. to extract the Low Gain signal
+  Int_t    fLoGainFirst;                   // First FADC slice nr. to extract the Low Gain signal
   Byte_t   fLoGainLast;                    // Last FADC slice nr. to extract the Low Gain signal
                                            
@@ -87,5 +87,5 @@
   Byte_t  GetHiGainFirst()      const { return fHiGainFirst;      }
   Byte_t  GetHiGainLast ()      const { return fHiGainLast ;      }
-  Byte_t  GetLoGainFirst()      const { return fLoGainFirst;      }
+  Int_t   GetLoGainFirst()      const { return fLoGainFirst;      }
   Byte_t  GetLoGainLast ()      const { return fLoGainLast ;      }
   Float_t GetNumHiGainSamples() const { return fNumHiGainSamples; }
@@ -102,5 +102,5 @@
   Float_t SetResolutionPerPheLoGain() const { return fResolutionPerPheLoGain; }
 
-  virtual void SetRange(Byte_t hifirst=0, Byte_t hilast=0, Byte_t lofirst=0, Byte_t lolast=0);
+  virtual void SetRange(Byte_t hifirst=0, Byte_t hilast=0, Int_t lofirst=0, Byte_t lolast=0);
 
   void SetOffsetLoGain    ( const Float_t  f=fgOffsetLoGain          ) { fOffsetLoGain     = f;    }